let tipID = 'tip'

let Cursor = function (element) {
	  this.element = element
	  this.isDeleting = true
	  this.currentText = element.textContent

	  this.loopCursor = 0
	  this.showCursor = true

	  this.dialog = 'welcome'

	  this.quoteNum = -1
	  this.quotes = {
		      'welcome': [
			            'Introduce os centímetros_ '
			          ],
		      'match': [
			            'A primeira científica que procuras é unha astrónoma e matemática galega moi famosa. Nada en Ourense fai máis dun seculo. ',
			            'Buscas a descubridora das estrelas pulsantes...ou púlsares. Vémonos despois de descodificar ',
			             'Académica da Real Academia de Farmacia de Galicia. Voltade despois de ler o xornal ',
			            'Moi ben. A nosa gran científica traballou en Univ. París e no MIT antes de vir a USC de Santiago. Está a desenvolver unha vacina contra a COVID-19. Volta despois de navegar ',
			            'Estás chegando ao final do periplo. Buscas a unha matemática lexendaria que traballou na NASA '
			          
			          ],
		      'error': [      
			            'Incorrecto! (Advertíronme que necesitaba ter paciencia...) ',
			            'Se volves fallar, terei que asegurarme de que non es un robot ',
			            'Resposta incorrecta. Revisa a pista ',
			            'Case coa, pero non é esa... ',
			            'Creo que non é a resposta correcta... '
			          ]
		    }

	  this.currentKey = 0
	  this.values = [ '24', 'CENIT', 'COVID', 'ALONSO', 'PERIPLO' ]
	  this.keys = ['>>', 'SUSTANTIVO (SEN ACENTOS)', 'DATO', 'CIENTÍFICA', 'SUSTANTIVO','BO TRABALLO']

	  document.getElementById(tipID).innerText = this.keys[this.currentKey]

	  this.tick()
}

Cursor.prototype.tick = function () {
	  if (this.isDeleting) {
		      this.currentText = this.currentText.substring(0, this.currentText.length - 1)
		    } else {
			        this.currentText = this.quotes[this.dialog][this.quoteNum].substring(0, this.currentText.length + 1)
			      }

	  this.element.innerHTML = this.currentText

	  if (this.showCursor) {
		      this.element.innerHTML = this.element.innerHTML.substring(0, this.element.textContent.length - 1) + '_'
		    } else {
			        this.element.innerHTML = this.element.innerHTML.substring(0, this.element.textContent.length - 1) + ' '
			      }

	  this.loopCursor = this.loopCursor === 6 ? 0 : this.loopCursor + 1
	  if (this.loopCursor === 0) this.showCursor = !this.showCursor

	  let that = this
	  let delta = 160 - Math.random() * 100
	  if (this.isDeleting) { delta /= 2 }

	  if (this.isDeleting && this.currentText === '') {
		      if(this.dialog === 'match') this.quoteNum = this.currentKey - 1
		      else this.quoteNum = Math.floor(Math.random() * this.quotes[this.dialog].length)
		      this.isDeleting = false
		    }

	  setTimeout(function () {
		      that.tick()
		    }, delta)
}

Cursor.prototype.parseData = function (data) {
	  let _data = data.toUpperCase().replace(new RegExp(' ', 'g'), '').replace(new RegExp('í', 'g'), 'I')

	  console.log(this.currentKey)
	  if (_data === 'adios' || _data === 'salir' || _data === 'cerrar') {
		      require('electron').remote.getCurrentWindow().close()
		    } else if (_data == 'reiniciar' || this.currentKey === this.values.length) {
			        require('electron').remote.getCurrentWindow().reload()
			      } else if (_data === this.values[this.currentKey]) {
				          this.currentKey++
				          this.dialog = 'match'
				          document.getElementById(tipID).innerText = this.keys[this.currentKey]
				          this.isDeleting = true
				        } else {
						    this.dialog = 'error'
						    this.isDeleting = true
						  }
}

function Terminal () {
	  let tip = document.getElementById('tip')
	  let terminal = document.getElementById('terminal')
	  setTimeout(function () {
		      cursor = new Cursor(terminal)
		    }, 1500) // Tiempo después del blink de la pantalla
}

document.getElementById('formulario').onsubmit = function (event) {
	  event.preventDefault()
	  if (cursor) {
		      cursor.parseData(document.getElementById('password').value)
		      document.getElementById('password').value = ''
		    }
	  return false
}

Terminal()
